/*==============================================================================
	Copyright (C) 2008 IT Access.,Co.Ltd. All Rights Reserved.
	
	This software is the confidential and proprietary information 
	of IT Access.,Co.Ltd.
	
	Note:
		For NXP LPC2388 + Kenic 351 (KS-LETQ) without OS.
	
	2009/10 T.Kou IT-Access

==============================================================================*/

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> INCLUDE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/

#include "LPC2300.h"

#include "GealTypes.h"
#include "TargetTypes.h"

#include "lcdlib.h"		/* 	*/

#ifndef	false
	#define	false	0
#endif

#ifndef	true
	#define	true	1
#endif

// ^b`pl̍WfobOp
//#define	_DEBUG_POS

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> CONFIGURATION. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/
#define DISPLAY_WIDTH	(TARGET_SCREEN_SIZE_X)
#define DISPLAY_HEIGHT	(TARGET_SCREEN_SIZE_Y)

// LCDʐݒ
#define	LCD_LINEINT	512		//s
#define	LCD_OFFSET	0x80ff0000	// BankjAANZX邱Ƃ\

static unsigned short  oldTx, oldTy ;
static unsigned char Ttgl, Told, Ton ;

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> TYPE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> MEMBER. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/

static TARGET		m_sTarget;

//@mallocȂ̂ŁAƂ肠萔ŊmہBVer1.3480Byte
#define	GEAL_SYSMEM_SIZE	512
static unsigned char GXSysMem[GEAL_SYSMEM_SIZE] ;

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> PROCEDURE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/


/********************************************************************
	荞LED_
********************************************************************/
/* LED_ŗpϐ */
static int LED_Blink;
static int 	DB_Cnt ;	// _uNbNOK

/* CPU荞݋ */
void CPU_EnableInterrupt(void)
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val &= ~0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞݋֎~ */
void CPU_DisableInterrupt(void)
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val |= 0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞ݏ */
int DispatchMessage(void);

void CPU_IRQInterrupt(void)
{
	DispatchMessage();
	if( LED_Blink == 0 ) {
		LED_Blink = 1;
		FIO1PIN =0x00000000;	/* P1[18] '0' -> LED ON */

	} else {
		LED_Blink = 0;
		FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
	}
	T0IR =1;		/* ^C}荞݃NA */
}

static void LPC2388_Vlink_LED( void )
{
	/* 荞݃Rg[ݒ */
	VICIntSelect = VICIntSelect & (~0x10);	/* IRQI */
	VICIntEnable = VICIntEnable |   0x10;	/* ^C}0̂ݗL */

	LED_Blink = 0 ;
	/* 荞݋ */
	CPU_EnableInterrupt();
}

/********************************************************************
	Init
********************************************************************/
static void LPC2388_PLLInit(void)
{
#define PLL_N		2UL
#define PLL_M		72UL
#define CCLK_DIV	4

	if ( PLLSTAT & (1 << 25) ) {
		PLLCON = 1;				/* Disconnect PLL output if PLL is in use */
		PLLFEED = 0xAA;
		PLLFEED = 0x55;
	}
	PLLCON = 0;				/* Disable PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	CLKSRCSEL = 0;			/* Select IRC (4MHz) as the PLL clock input */

	PLLCFG = ((PLL_N - 1) << 16) | (PLL_M - 1);	/* Re-configure PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	PLLCON = 1;				/* Enable PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	while ((PLLSTAT & (1 << 26)) == 0);	/* Wait for PLL locked */

	CCLKCFG = CCLK_DIV-1;	/* Select CCLK frequency (divide ratio of hclk) */
	PLLCON = 3;				/* Connect PLL output to the sysclk */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	MAMCR = 0;				/* Configure MAM for 72MHz operation */
	MAMTIM = 3;
	MAMCR = 2;
}

static void LPC2388Init( void )
{
	LPC2388_PLLInit() ;

	SCS = SCS | 1;	/* FGPIO Select */

	/* LED_ݒ */
	FIO1DIR = 0x00040000;	/* P1[18] OutPut */
	FIO1MASK = 0x00000000;	/* P1[18] Non Mask */
	FIO1PIN = 0x00040000;	/* P1[18] '1' -> LED OFF */

	/* ^C}Rg[ւ̋NbNݒ */
	PCLKSEL0 = (PCLKSEL0 & 0xfffffff3); /* 1/4 */

	/* ^C}0̃p[^ݒ */
	T0PR  = 0x00000000;		/* vXP[ */
	T0MR0 = 1000000;			/* NbNg=1b */
	T0MCR = 0x00000003;		/* MatchTCNA&荞 */
	T0TCR = 1;	/* ^C}X^[g*/

	/* SRAMRg[ݒ */
	PCONP = 0x06280FFE;			/* lށ@*/
/*	EMC_STAT = 0x6; */			/* */
	PINSEL6 = 0x00005555;		/* Pin Serect Data Set */
	PINSEL8 = 0x55555555;		/* Pin Serect Address Set */
	PINSEL9 = 0x50090000;		/* Pin Serect CS1/0 & BLS & CE Set */

	EMC_CTRL = 0x0001 ;	// default =3 , bit1 Mirror -> Normal memory map
}


/********************************************************************
	֐
		fnLCDInit
	
		Ȃ
	߂l
		Ȃ
	
		LCDRg[֘AOϐ̏ōs
		CPUN1x̊֐Ă
********************************************************************/
void fnLCDInit(void)
{
	unsigned int i;

	/*LCDRg[*/
//	fnSetReg1( 0x00 );	/* Penetrate enable , Blink1 enable Blink2 disable */
	fnSetReg1( 0x70 );	/* Colorpalette(64color) Penetrate enable , Blink1 enable Blink2 enable */
	fnSetReg2( 0x00 );
	fnSetReg3( 0x05 );
//	fnSetReg4( 0x7f );	/* MAX LED backlight duty */
	fnSetReg4( 0x64 );

//	set_default_colormap(); 
}

static void LCD_set_palette( const GE_COLOR* pal, int num )
{
	int i ;
	unsigned char r,g,b ;

	for( i=0; i<num; i++, pal++ ){
		r = GE_GetRValue(*pal);
		g = GE_GetGValue(*pal);
		b = GE_GetBValue(*pal);
		fnSetColorMap( (unsigned char)(2*i),
				(unsigned char)( (g&0xf0) | ((b&0xf0)>>4) ) );
			fnSetColorMap( (unsigned char)(2*i+1),
				(unsigned char)( (r&0xf0) >> 4 ) );
	}
}


int DispatchMessage(void)
{
	int ret;
	unsigned short  Tx, Ty ;
#define	TPX	4
#define	TPY	216
#define	TPCFG	61
#define	TPCBG	17

	if ( touch_read( &Tx, &Ty ) ) {
#ifdef	_DEBUG_POS
		fn7seg( TPX, TPY,Tx,3, TPCFG,TPCBG);	/*Ww肵ĂR̂VZO\܂B*/
		fn7seg( TPX+70, TPY,Ty,3, TPCFG,TPCBG);	/*Ww肵ĂR̂VZO\܂B*/
#endif
		// Ă
		oldTx = Tx ;
		oldTy = Ty ;
		Told = Ton ;
		Ton = 1 ;
//		Ttgl = (~Told) & Ton ;
		if (! Ttgl) {	// ꂽ񂾂
#ifdef	_DEBUG_POS
			fn7seg( TPX+140, TPY, Ttgl=1, 1, TPCFG,TPCBG);
#endif
			GxMsgSend(eGEMSG_MOUSEDOWN, 0,
				(((GE_UINT16)Ty) << 16) | ((GE_UINT16)Tx));
//			if ( DB_Cnt > )  ;	// _uNbNOK

		}
	}
	else { // ĂȂ
		Told = Ton ;
		Ttgl = Ton = 0 ;
		if ( oldTx | oldTy ) {	// Ō̍W=MOUSEUP
#ifdef	_DEBUG_POS
			fn7seg( TPX+140, TPY,Ttgl, 1, TPCFG,TPCBG);
#endif
			GxMsgSend(eGEMSG_MOUSEUP, 0,
					(((GE_UINT16)oldTy) << 16) | ((GE_UINT16)oldTx));
			oldTx = oldTy = 0 ;
		}
	}

	return true ;	//Always return true, no quit
}


int main(int argc, char * argv[])
{
	GE_POINT pos ;

	LPC2388Init() ;
	fnLCDInit();	/* LCD 351 */

	oldTx = oldTy = 0 ;
	Ttgl = Told = Ton = 0;

	// Graphic^[Qbg
	m_sTarget.wX = DISPLAY_WIDTH ;
	m_sTarget.wY = DISPLAY_HEIGHT ;
	m_sTarget.pBits = (GE_VOID *)LCD_OFFSET ;
	m_sTarget.dwLineByte = LCD_LINEINT ;	//sw@CLUT8=1byte

	// Copy Palette.
	LCD_set_palette( (const GE_COLOR*)GxSysPaletteGet(), 64 );

	// GEAL Engine ̃VXeʑŊmۂ
	UGxMemset( GXSysMem, 0, sizeof(GXSysMem) ) ;

	GxInitialize(GXSysMem);

	LPC2388_Vlink_LED() ;

	// Cxg[v
	while (1)
	{
		GxProcess();
	}

	// GealI
	GxFinalize();

	return 0;
}

/*------------------------------------------------------------------------------
	This API gets current target.
------------------------------------------------------------------------------*/
HTARGET UGxTargetGet()
{
	return (HTARGET)&m_sTarget;
}

